Index: trunk/gui/scripts/tooltip.tcl
===================================================================
--- trunk/gui/scripts/tooltip.tcl	(revision 6716)
+++ trunk/gui/scripts/tooltip.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: tooltip - help information that pops up beneath a widget
@@ -18,8 +17,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
@@ -28,6 +24,6 @@
 option add *Tooltip.outline black widgetDefault
 option add *Tooltip.borderwidth 1 widgetDefault
-option add *Tooltip.font -*-helvetica-medium-r-normal-*-12-* widgetDefault
-option add *Tooltip.wrapLength 4i widgetDefault
+option add *Tooltip.font -*-helvetica-medium-r-normal-*-*-120-* widgetDefault
+option add *Tooltip.wrapLength 3i widgetDefault
 
 itcl::class Rappture::Tooltip {
@@ -37,5 +33,4 @@
     itk_option define -icon icon Icon ""
     itk_option define -message message Message ""
-    itk_option define -log log Log ""
 
     constructor {args} { # defined below }
@@ -44,11 +39,8 @@
     public method hide {}
 
-    private variable _showing 0  ;# time when tooltip popped up on screen
-
-    public proc for {widget text args}
-    public proc text {widget args}
-    private common catalog    ;# maps widget => -message and -log
-
-    public proc tooltip {option args}
+    public proc for {widget args}
+    private common catalog    ;# maps widget => message
+
+    public proc tooltip {option {widget ""}}
     private common pending "" ;# after ID for pending "tooltip show"
 
@@ -63,4 +55,8 @@
     bind RapptureTooltip <KeyPress> \
         [list ::Rappture::Tooltip::tooltip cancel]
+
+    private common icons
+    set dir [file dirname [info script]]
+    set icons(cue) [image create photo -file [file join $dir images cue24.gif]]
 }
 
@@ -95,10 +91,9 @@
 
 # ----------------------------------------------------------------------
-# USAGE: show @<x>,<y>|<widget>+/-<x>,<y>
+# USAGE: show @<x>,<y>|<widget>
 #
 # Clients use this to pop up the tooltip on the screen.  The position
-# should be either a <widget> name with an optional offset +/-<x>,<y>
-# (tooltip pops up beneath widget by default), or a specific root
-# window coordinate of the form @x,y.
+# should be either a <widget> name (tooltip pops up beneath widget)
+# or a specific root window coordinate of the form @x,y.
 #
 # If the -message has the form "@command", then the command is executed
@@ -107,22 +102,12 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Tooltip::show {where} {
-    set hull $itk_component(hull)
-    set _showing 0
-
-    set signx "+"
-    set signy "+"
-
     if {[regexp {^@([0-9]+),([0-9]+)$} $where match x y]} {
         set xpos $x
         set ypos $y
-    } elseif {[regexp {^(.*)([-+])([0-9]+),([-+]?)([0-9]+)$} $where match win signx x signy y]} {
-        if {$signy == ""} { set signy $signx }
-        set xpos [expr {[winfo rootx $win] + $x}]
-        set ypos [expr {[winfo rooty $win] + $y}]
     } elseif {[winfo exists $where]} {
         set xpos [expr {[winfo rootx $where]+10}]
         set ypos [expr {[winfo rooty $where]+[winfo height $where]}]
     } else {
-        error "bad position \"$where\": should be widget+x,y, or @x,y"
+        error "bad position \"$where\": should be widget name or @x,y"
     }
 
@@ -137,93 +122,11 @@
     }
 
-    # if there's no message to show, forget it
-    if {[string length $mesg] == 0} {
-        return
-    }
-
-    # strings can't be too big, or they'll go off screen!
-    set pos 0
-    ::for {set i 0} {$pos >= 0 && $i < 20} {incr i} {
-        incr pos
-        set pos [string first \n $mesg $pos]
-    }
-    if {$pos > 0} {
-        set mesg "[string range $mesg 0 $pos]..."
-    }
-    if {[string length $mesg] > 1000} {
-        set mesg "[string range $mesg 0 1500]..."
-    }
     $itk_component(text) configure -text $mesg
 
-    #
-    # Make sure the tooltip doesn't go off screen.
-    #
-    update idletasks
-    if {$signx == "+"} {
-        if {$xpos+[winfo reqwidth $hull] > [winfo screenwidth $hull]} {
-            set xpos [expr {[winfo screenwidth $hull]-[winfo reqwidth $hull]}]
-        }
-        if {$xpos < 0} { set xpos 0 }
-    } else {
-        if {$xpos-[winfo reqwidth $hull] < 0} {
-            set xpos [expr {[winfo screenwidth $hull]-[winfo reqwidth $hull]}]
-        }
-        set xpos [expr {[winfo screenwidth $hull]-$xpos}]
-    }
-
-    if {$signy == "+"} {
-        if {$ypos+[winfo reqheight $hull] > [winfo screenheight $hull]} {
-            set ypos [expr {[winfo screenheight $hull]-[winfo reqheight $hull]}]
-        }
-        if {$ypos < 0} { set ypos 0 }
-    } else {
-        if {$ypos-[winfo reqheight $hull] < 0} {
-            set ypos [expr {[winfo screenheight $hull]-[winfo reqheight $hull]}]
-        }
-        set ypos [expr {[winfo screenheight $hull]-$ypos}]
-    }
-
-    #
-    # Will the tooltip pop up under the mouse pointer?  If so, then
-    # it will just disappear.  Doh!  We should figure out a better
-    # place to pop it up.
-    #
-    set px [winfo pointerx $hull]
-    set py [winfo pointery $hull]
-    if {$px >= $xpos && $px <= $xpos+[winfo reqwidth $hull]
-          && $py >= $ypos && $py <= $ypos+[winfo reqheight $hull]} {
-
-        if {$px > [winfo screenwidth $hull]/2} {
-            set signx "-"
-            set xpos [expr {[winfo screenwidth $hull]-$px+4}]
-        } else {
-            set signx "+"
-            set xpos [expr {$px+4}]
-        }
-        if {$py > [winfo screenheight $hull]/2} {
-            set signy "-"
-            set ypos [expr {[winfo screenheight $hull]-$py+4}]
-        } else {
-            set signy "+"
-            set ypos [expr {$py+4}]
-        }
-    }
-
-    #
-    # Finally, put it up.
-    #
-    wm geometry $hull $signx$xpos$signy$ypos
+    wm geometry $itk_component(hull) +$xpos+$ypos
     update
 
-    wm deiconify $hull
-    raise $hull
-
-    #
-    # If logging is enabled, grab the start time.  We'll need this
-    # info later during the "hide" step to log activity.
-    #
-    if {$itk_option(-log) ne ""} {
-        set _showing [clock seconds]
-    }
+    wm deiconify $itk_component(hull)
+    raise $itk_component(hull)
 }
 
@@ -235,20 +138,8 @@
 itcl::body Rappture::Tooltip::hide {} {
     wm withdraw $itk_component(hull)
-
-    #
-    # If logging is enabled and the time is non-zero, then log
-    # the activity on this tooltip.
-    #
-    if {$itk_option(-log) ne "" && $_showing > 0} {
-        set dt [expr {[clock seconds] - $_showing}]
-        if {$dt > 0} {
-            Rappture::Logger::log tooltip -for $itk_option(-log) -time $dt
-        }
-    }
-    set _showing 0
-}
-
-# ----------------------------------------------------------------------
-# USAGE: for <widget> <text> ?-log <name>?
+}
+
+# ----------------------------------------------------------------------
+# USAGE: for <widget> <text>
 #
 # Used to register the tooltip <text> for a particular <widget>.
@@ -260,21 +151,7 @@
 # If the <text> has the form "@command", then the command is executed
 # just before the tip pops up to build the message on-the-fly.
-#
-# The -log option turns logging on/off for this tooltip.  Logging is
-# useful when you want to keep track of whether the user is looking at
-# tooltips and for how long.  If the <name> is specified, then any
-# activity on the tooltip is reported with that name on the log line.
-# If the name is not specified or "", then the activity is not logged.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Tooltip::for {widget text args} {
-    Rappture::getopts args params {
-        value -log ""
-    }
-    if {[llength $args] > 0} {
-        error "wrong # args: should be \"for widget text ?-log name?\""
-    }
-
-    set catalog($widget-message) $text
-    set catalog($widget-log) $params(-log)
+# ----------------------------------------------------------------------
+itcl::body Rappture::Tooltip::for {widget text} {
+    set catalog($widget) $text
 
     set btags [bindtags $widget]
@@ -289,36 +166,6 @@
 
 # ----------------------------------------------------------------------
-# USAGE: text <widget> ?<text>? ?-log name?
-#
-# Used to query or set the text used for the tooltip for a widget.
-# This is done automatically when you call the "for" proc, but it
-# is sometimes handy to query or change the text later.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Tooltip::text {widget args} {
-    if {[llength $args] == 0} {
-        if {[info exists catalog($widget-message)]} {
-            return $catalog($widget-message)
-        }
-        return ""
-    }
-
-    # set the text for the tooltip
-    set str [lindex $args 0]
-    set args [lrange $args 1 end]
-
-    Rappture::getopts args params {
-        value -log ""
-    }
-    if {[llength $args] > 0} {
-        error "wrong # args: should be \"text widget ?str? ?-log name?\""
-    }
-
-    set catalog($widget-message) $str
-    set catalog($widget-log) $params(-log)
-}
-
-# ----------------------------------------------------------------------
-# USAGE: tooltip pending <widget> ?@<x>,<y>|+<x>,<y>?
-# USAGE: tooltip show <widget> ?@<x>,<y>|+<x>,<y>?
+# USAGE: tooltip pending <widget>
+# USAGE: tooltip show
 # USAGE: tooltip cancel
 #
@@ -329,46 +176,19 @@
 # bindings take over.
 # ----------------------------------------------------------------------
-itcl::body Rappture::Tooltip::tooltip {option args} {
+itcl::body Rappture::Tooltip::tooltip {option {widget ""}} {
     switch -- $option {
         pending {
-            if {[llength $args] < 1 || [llength $args] > 2} {
-                error "wrong # args: should be \"tooltip pending widget ?@x,y?\""
-            }
-            set widget [lindex $args 0]
-            set loc [lindex $args 1]
-
-            if {![info exists catalog($widget-message)]} {
-                return;                        # No tooltip for widget.
+            if {![info exists catalog($widget)]} {
+                error "can't find tooltip for $widget"
             }
             if {$pending != ""} {
                 after cancel $pending
             }
-            set pending [after 750 [itcl::code tooltip show $widget $loc]]
+            set pending [after 1500 [itcl::code tooltip show $widget]]
         }
         show {
-            if {[llength $args] < 1 || [llength $args] > 2} {
-                error "wrong # args: should be \"tooltip show tag loc\""
-            }
-            set tag [lindex $args 0]
-            set loc [lindex $args 1]
-
-            # tag name may be .g-axis -- get widget ".g" part
-            set widget $tag
-            if {[regexp {^(\.[^-]+)-[^\.]+$} $widget match wname]} {
-                set widget $wname
-            }
-
-            if {[winfo exists $widget] && [info exists catalog($tag-message)]} {
-                .rappturetooltip configure \
-                    -message $catalog($tag-message) \
-                    -log $catalog($tag-log)
-
-                if {[string index $loc 0] == "@"} {
-                    .rappturetooltip show $loc
-                } elseif {[regexp {^[-+]} $loc]} {
-                    .rappturetooltip show $widget$loc
-                } else {
-                    .rappturetooltip show $widget
-                }
+            if {[winfo exists $widget]} {
+                .rappturetooltip configure -message $catalog($widget)
+                .rappturetooltip show $widget
             }
         }
@@ -455,22 +275,10 @@
 }
 
-# ----------------------------------------------------------------------
-# CONFIGURATION OPTION: -log
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Tooltip::log {
-    # logging options changed -- reset showing time
-    set _showing 0
-}
-
 # create a tooltip widget to show tool tips
 Rappture::Tooltip .rappturetooltip
 
-# any click on any widget takes down the tooltip
-bind all <Leave> [list ::Rappture::Tooltip::tooltip cancel]
-bind all <ButtonPress> [list ::Rappture::Tooltip::tooltip cancel]
-
 # create a tooltip widget to show error cues
 Rappture::Tooltip .rappturetoolcue \
-    -icon [Rappture::icon cue24] \
+    -icon $Rappture::Tooltip::icons(cue) \
     -background black -outline #333333 -foreground white
 
Index: trunk/gui/scripts/units.tcl
===================================================================
--- trunk/gui/scripts/units.tcl	(revision 6716)
+++ trunk/gui/scripts/units.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: units - mechanism for converting numbers with units
@@ -8,8 +7,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itcl
@@ -61,167 +57,4 @@
 }
 
-
-# ----------------------------------------------------------------------
-# USAGE: mcheck_range value {min ""} {max ""}
-#
-# Checks a value or PDF to determine if is is in a required range.
-# Automatically does unit conversion if necessary.
-# Returns value if OK.  Error if out-of-range
-# Examples:
-#    [mcheck_range "gaussian 0C 1C" 200K 500K] returns 1
-#    [mcheck_range "uniform 100 200" 150 250] returns 0
-#    [mcheck_range 100 0 200] returns 1
-# ----------------------------------------------------------------------
-
-proc Rappture::Units::_check_range {value min max units} {
-    # puts "_check_range $value min=$min max=$max units=$units"
-    # make sure the value has units
-    if {$units != ""} {
-        set value [Rappture::Units::convert $value -context $units]
-        # for comparisons, remove units
-        set nv [Rappture::Units::convert $value -context $units -units off]
-        # get the units for the value
-        set newunits [Rappture::Units::Search::for $value]
-    } else {
-        set nv $value
-    }
-
-    if {"" != $min} {
-        if {"" != $units} {
-            # compute the minimum in the new units
-            set minv [Rappture::Units::convert $min -to $newunits -context $units  -units off]
-            # same, but include units for printing
-            set convMinVal [Rappture::Units::convert $min -to $newunits -context $units]
-        } else {
-            set minv $min
-            set convMinVal $min
-        }
-        if {$nv < $minv} {
-            error "Minimum value allowed here is $convMinVal"
-        }
-    }
-    if {"" != $max} {
-        if {"" != $units} {
-            # compute the maximum in the new units
-            set maxv [Rappture::Units::convert $max -to $newunits -context $units -units off]
-            # same, but include units for printing
-            set convMaxVal [Rappture::Units::convert $max -to $newunits -context $units ]
-        } else {
-            set maxv $max
-            set convMaxVal $max
-        }
-        if {$nv > $maxv} {
-            error "Maximum value allowed here is $convMaxVal"
-        }
-    }
-    return $value
-}
-
-proc Rappture::Units::mcheck_range {value {min ""} {max ""} {units ""}} {
-    # puts "mcheck_range $value min=$min max=$max units=$units"
-
-    switch -- [lindex $value 0] {
-        normal -
-        gaussian {
-            # get the mean
-            set mean [_check_range [lindex $value 1] $min $max $units]
-            if {$units == ""} {
-                set dev [lindex $value 2]
-                set ndev $dev
-            } else {
-                set dev [Rappture::Units::convert [lindex $value 2] -context $units]
-                set ndev [Rappture::Units::convert $dev -units off]
-            }
-            if {$ndev <= 0} {
-                error "Deviation must be positive."
-            }
-            return [list gaussian $mean $dev]
-        }
-        uniform {
-            set min [_check_range [lindex $value 1] $min $max $units]
-            set max [_check_range [lindex $value 2] $min $max $units]
-            return [list uniform $min $max]
-        }
-        exact  {
-            return [_check_range [lindex $value 1] $min $max $units]
-        }
-        default {
-            return [_check_range [lindex $value 0] $min $max $units]
-        }
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: mconvert value ?-context units? ?-to units? ?-units on/off?
-#
-# This version of convert() converts multiple values.  Used when the
-# value could be a range or probability density function (PDF).
-# Examples:
-#    gaussian 100k 1k
-#    uniform 0eV 10eV
-#    42
-#    exact 42
-# ----------------------------------------------------------------------
-
-proc Rappture::Units::mconvert {value args} {
-    # puts "mconvert $value : $args"
-    array set opts {
-        -context ""
-        -to ""
-        -units "on"
-    }
-
-    set value [split $value]
-
-    switch -- [lindex $value 0] {
-        normal - gaussian {
-            set valtype gaussian
-            set vals [lrange $value 1 2]
-            set convtype {0 1}
-        }
-        uniform {
-            set valtype uniform
-            set vals [lrange $value 1 2]
-            set convtype {0 0}
-        }
-        exact  {
-            set valtype ""
-            set vals [lindex $value 1]
-            set convtype {0}
-        }
-        default {
-            set valtype ""
-            set vals $value
-            set convtype {0}
-        }
-    }
-
-    foreach {key val} $args {
-        if {![info exists opts($key)]} {
-            error "bad option \"$key\": should be [join [lsort [array names opts]] {, }]"
-        }
-        set opts($key) $val
-    }
-
-    set newval $valtype
-    foreach val $vals ctype $convtype {
-        if {$ctype == 1} {
-            # This code handles unit conversion for deltas (changes).
-            # For example, if we want a standard deviation of 10C converted
-            # to Kelvin, that is 10K, NOT a standard deviation of 283.15K.
-            set units [Rappture::Units::Search::for $val]
-            set base [eval Rappture::Units::convert 0$units $args -units off]
-            set new [eval Rappture::Units::convert $val $args -units off]
-            set delta [expr $new - $base]
-            set val $delta$opts(-to)
-        }
-        # tcl 8.5 allows us to do this:
-        # lappend newval [Rappture::Units::convert $val {*}$args]
-        # but we are using tcl8.4 so we use eval :^(
-        lappend newval [eval Rappture::Units::convert $val $args]
-    }
-    return $newval
-}
-
 # ----------------------------------------------------------------------
 # USAGE: convert value ?-context units? ?-to units? ?-units on/off?
@@ -233,7 +66,54 @@
 # current system.
 # ----------------------------------------------------------------------
-# proc Rappture::Units::convert {value args} {}
-# Actual implementation is in rappture/lang/tcl/src/RpUnitsTclInterface.cc.
-
+proc Rappture::Units::convert {value args} {
+    array set opts {
+        -context ""
+        -to ""
+        -units "on"
+    }
+    foreach {key val} $args {
+        if {![info exists opts($key)]} {
+            error "bad option \"$key\": should be [join [lsort [array names opts]] {, }]"
+        }
+        set opts($key) $val
+    }
+
+    #
+    # Parse the value into the number part and the units part.
+    #
+    set value [string trim $value]
+    if {![regexp {^([-+]?[0-9]+\.?([0-9]+)?([eEdD][-+]?[0-9]+)?) *(/?[a-zA-Z]+[0-9]*)?$} $value match number dummy1 dummy2 units]} {
+        set mesg "bad value \"$value\": should be real number with units"
+        if {$opts(-context) != ""} {
+            append mesg " of [Rappture::Units::description $opts(-context)]"
+        }
+        error $mesg
+    }
+    if {$units == ""} {
+        set units $opts(-context)
+    }
+
+    #
+    # Try to find the object representing the current system of units.
+    #
+    set units [Rappture::Units::System::regularize $units]
+    set oldsys [Rappture::Units::System::for $units]
+    if {$oldsys == ""} {
+        set mesg "value \"$value\" has unrecognized units"
+        if {$opts(-context) != ""} {
+            append mesg ".\nShould be units of [Rappture::Units::description $opts(-context)]"
+        }
+        error $mesg
+    }
+
+    #
+    # Convert the number to the new system of units.
+    #
+    if {$opts(-to) == ""} {
+        # no units -- return the number as is
+        return "$number$units"
+    }
+    return [$oldsys convert "$number$units" $opts(-to) $opts(-units)]
+}
 
 # ----------------------------------------------------------------------
@@ -244,7 +124,16 @@
 # along with a list of all compatible systems.
 # ----------------------------------------------------------------------
-# proc Rappture::Units::description {units} {}
-# Actual implementation is in rappture/lang/tcl/src/RpUnitsTclInterface.cc.
-
+proc Rappture::Units::description {units} {
+    set sys [Rappture::Units::System::for $units]
+    if {$sys == ""} {
+        return ""
+    }
+    set mesg [$sys cget -type]
+    set ulist [Rappture::Units::System::all $units]
+    if {"" != $ulist} {
+        append mesg " ([join $ulist {, }])"
+    }
+    return $mesg
+}
 
 # ----------------------------------------------------------------------
@@ -261,8 +150,6 @@
     private variable _system ""  ;# this system of units
 
-    # These are in rappture/lang/tcl/src/RpUnitsTclInterface.cc.
-    # public proc for {units}
-    # public proc all {units}
-
+    public proc for {units}
+    public proc all {units}
     public proc regularize {units}
 
@@ -470,7 +357,49 @@
 # if there is no system that matches the units string.
 # ----------------------------------------------------------------------
-# itcl::body Rappture::Units::System::for {units} {}
-# Actual implementation is in rappture/lang/tcl/src/RpUnitsTclInterface.cc.
-
+itcl::body Rappture::Units::System::for {units} {
+    #
+    # See if the units are a recognized system.  If not, then try to
+    # extract any metric prefix and see if what's left is a recognized
+    # system.  If all else fails, see if we can find a system without
+    # the exact capitalization.  The user might say "25c" instead of
+    # "25C".  Try to allow that.
+    #
+    if {[info exists _base($units)]} {
+        return $_base($units)
+    } else {
+        set orig $units
+        if {[regexp {^(/?)[cCmMuUnNpPfFaAkKgGtT](.+)$} $units match slash tail]} {
+            set base "$slash$tail"
+            if {[info exists _base($base)]} {
+                set sys $_base($base)
+                if {[$sys cget -metric]} {
+                    return $sys
+                }
+            }
+
+            # check the base part for improper capitalization below...
+            set units $base
+        }
+
+        set matching ""
+        foreach u [array names _base] {
+            if {[string equal -nocase $u $units]} {
+                lappend matching $_base($u)
+            }
+        }
+        if {[llength $matching] == 1} {
+            set sys [lindex $matching 0]
+            #
+            # If we got rid of a metric prefix above, make sure
+            # that the system is metric.  If not, then we don't
+            # have a match.
+            #
+            if {[string equal $units $orig] || [$sys cget -metric]} {
+                return $sys
+            }
+        }
+    }
+    return ""
+}
 
 # ----------------------------------------------------------------------
@@ -481,7 +410,26 @@
 # relationships that lead to the same base system.
 # ----------------------------------------------------------------------
-# itcl::body Rappture::Units::System::all {units} {}
-# Actual implementation is in rappture/lang/tcl/src/RpUnitsTclInterface.cc.
-
+itcl::body Rappture::Units::System::all {units} {
+    set sys [Rappture::Units::System::for $units]
+    if {$sys == ""} {
+        return ""
+    }
+
+    if {"" != [$sys cget -basis]} {
+        set basis [lindex [$sys cget -basis] 0]
+    } else {
+        set basis $units
+    }
+
+    set ulist $basis
+    foreach u [array names _base] {
+        set obj $_base($u)
+        set b [lindex [$obj cget -basis] 0]
+        if {$b == $basis} {
+            lappend ulist $u
+        }
+    }
+    return $ulist
+}
 
 # ----------------------------------------------------------------------
@@ -499,5 +447,5 @@
     }
     # note: case-insensitive matching for metric prefix
-    if {[regexp {^(/?)([cCmMuUnNpPfFaAkKgGtT]?)([a-zA-Z]+[0-9]+|[a-zA-Z]+)$} $units match slash prefix tail]} {
+    if {[regexp {^(/?)([cCmMuUnNpPfFaAkKgGtT])(.+)$} $units match slash prefix tail]} {
         if {[regexp {^[CUNFAK]$} $prefix]} {
             # we know that these should be lower case
@@ -521,5 +469,4 @@
 
 Rappture::Units::define /m3 -type density -metric yes
-Rappture::Units::define /m2 -type misc -metric yes
 
 Rappture::Units::define C -type temperature -metric no
@@ -527,21 +474,3 @@
 Rappture::Units::define F->C {(F-32)/1.8} {(1.8*C)+32}
 
-Rappture::Units::define eV -type energy -metric yes
-Rappture::Units::define J->eV {J/1.602177e-19} {eV*1.602177e-19}
-
-Rappture::Units::define V -type voltage -metric yes
-
-Rappture::Units::define s -type seconds -metric yes
-# can't use min becase tcl thinks its milli-in's
-# Rappture::Units::define min->s {min*60.00} {s/60.00}
-Rappture::Units::define h->s {h*3600.00} {s/3600.00}
-Rappture::Units::define d->s {d*86400.00} {s/86400.00}
-
-# can't put mol's in because tcl thinks its milli-ol's
-# Rappture::Units::define mol -type misc -metric yes
-Rappture::Units::define Hz -type misc -metric yes
-Rappture::Units::define Bq -type misc -metric yes
-
-Rappture::Units::define deg -type angle -metric no
-Rappture::Units::define rad -type angle -metric no
-Rappture::Units::define deg->rad {deg*(3.1415926535897931/180.00)} {rad*(180.00/3.1415926535897931)}
+Rappture::Units::define eV -type potential -metric yes
